<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SumSqHousesUnderMngStartPeriod StructType
 * @subpackage Structs
 */
class SumSqHousesUnderMngStartPeriod extends AbstractStructBase
{
    /**
     * The sum_sq_houses_under_mng_start_period
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var float
     */
    public $sum_sq_houses_under_mng_start_period;
    /**
     * The sum_sq_houses_concluded_contracts
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var float
     */
    public $sum_sq_houses_concluded_contracts;
    /**
     * The sum_sq_houses_terminated_contracts
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var float
     */
    public $sum_sq_houses_terminated_contracts;
    /**
     * Constructor method for SumSqHousesUnderMngStartPeriod
     * @uses SumSqHousesUnderMngStartPeriod::setSum_sq_houses_under_mng_start_period()
     * @uses SumSqHousesUnderMngStartPeriod::setSum_sq_houses_concluded_contracts()
     * @uses SumSqHousesUnderMngStartPeriod::setSum_sq_houses_terminated_contracts()
     * @param float $sum_sq_houses_under_mng_start_period
     * @param float $sum_sq_houses_concluded_contracts
     * @param float $sum_sq_houses_terminated_contracts
     */
    public function __construct($sum_sq_houses_under_mng_start_period = null, $sum_sq_houses_concluded_contracts = null, $sum_sq_houses_terminated_contracts = null)
    {
        $this
            ->setSum_sq_houses_under_mng_start_period($sum_sq_houses_under_mng_start_period)
            ->setSum_sq_houses_concluded_contracts($sum_sq_houses_concluded_contracts)
            ->setSum_sq_houses_terminated_contracts($sum_sq_houses_terminated_contracts);
    }
    /**
     * Get sum_sq_houses_under_mng_start_period value
     * @return float|null
     */
    public function getSum_sq_houses_under_mng_start_period()
    {
        return $this->sum_sq_houses_under_mng_start_period;
    }
    /**
     * Set sum_sq_houses_under_mng_start_period value
     * @param float $sum_sq_houses_under_mng_start_period
     * @return \StructType\SumSqHousesUnderMngStartPeriod
     */
    public function setSum_sq_houses_under_mng_start_period($sum_sq_houses_under_mng_start_period = null)
    {
        // validation for constraint: float
        if (!is_null($sum_sq_houses_under_mng_start_period) && !(is_float($sum_sq_houses_under_mng_start_period) || is_numeric($sum_sq_houses_under_mng_start_period))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($sum_sq_houses_under_mng_start_period, true), gettype($sum_sq_houses_under_mng_start_period)), __LINE__);
        }
        $this->sum_sq_houses_under_mng_start_period = $sum_sq_houses_under_mng_start_period;
        return $this;
    }
    /**
     * Get sum_sq_houses_concluded_contracts value
     * @return float|null
     */
    public function getSum_sq_houses_concluded_contracts()
    {
        return $this->sum_sq_houses_concluded_contracts;
    }
    /**
     * Set sum_sq_houses_concluded_contracts value
     * @param float $sum_sq_houses_concluded_contracts
     * @return \StructType\SumSqHousesUnderMngStartPeriod
     */
    public function setSum_sq_houses_concluded_contracts($sum_sq_houses_concluded_contracts = null)
    {
        // validation for constraint: float
        if (!is_null($sum_sq_houses_concluded_contracts) && !(is_float($sum_sq_houses_concluded_contracts) || is_numeric($sum_sq_houses_concluded_contracts))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($sum_sq_houses_concluded_contracts, true), gettype($sum_sq_houses_concluded_contracts)), __LINE__);
        }
        $this->sum_sq_houses_concluded_contracts = $sum_sq_houses_concluded_contracts;
        return $this;
    }
    /**
     * Get sum_sq_houses_terminated_contracts value
     * @return float|null
     */
    public function getSum_sq_houses_terminated_contracts()
    {
        return $this->sum_sq_houses_terminated_contracts;
    }
    /**
     * Set sum_sq_houses_terminated_contracts value
     * @param float $sum_sq_houses_terminated_contracts
     * @return \StructType\SumSqHousesUnderMngStartPeriod
     */
    public function setSum_sq_houses_terminated_contracts($sum_sq_houses_terminated_contracts = null)
    {
        // validation for constraint: float
        if (!is_null($sum_sq_houses_terminated_contracts) && !(is_float($sum_sq_houses_terminated_contracts) || is_numeric($sum_sq_houses_terminated_contracts))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($sum_sq_houses_terminated_contracts, true), gettype($sum_sq_houses_terminated_contracts)), __LINE__);
        }
        $this->sum_sq_houses_terminated_contracts = $sum_sq_houses_terminated_contracts;
        return $this;
    }
}
